/*
   *Copyright:  

   ACEMod (2018--2021), The University of Sydney's invention disclosure CDIP Ref. 2019-123.
   Copyright ©  Oliver Cliff, Cameron Zachreson, Nathan Harding, Kristopher Fair, Mikhail Prokopenko, Mahendarajah Piraveenan

   AMTraC-19 (2020-2021), The University of Sydney's invention disclosure CDIP 2020-018 (2020).
   Copyright ©  Sheryl Chang, Nathan Harding, Cameron Zachreson, Oliver Cliff, Mikhail Prokopenko

   AMTraC-19 (2022-2023), The University of Sydney.
   Copyright ©  Sheryl Chang, Quang Dang Nguyen, Nathan Harding, Cameron Zachreson, Oliver Cliff, Mikhail Prokopenko

   AMTraC-19 (2024), The University of Sydney.
   Copyright ©  Quang Dang Nguyen, Sheryl Chang, Nathan Harding, Cameron Zachreson, Oliver Cliff, Mikhail Prokopenko

   *EndCopyright:
*/

#ifndef  IMMUNITY_H_
#define  IMMUNITY_H_

#include "virus.h"
#include "enums.h"

class Immunity {
    public: 
        Immunity( 
            unsigned a_date,
            float VEc,
            float VEt,
            float daily_waning_VEc,
            float daily_waning_VEt,
            Immunisation_Type immunisation
        ) {
            this->date = a_date;
            this->VEc = VEc;
            this->daily_waning_VEc = daily_waning_VEc;
            this->VEt = VEt;
            this->daily_waning_VEt = daily_waning_VEt;
            this->immunisation = immunisation;
        }

        unsigned get_date(void) {
            return date;
        }

        float get_VEc(void) {
            return VEc;
        }

        float get_daily_waning_VEc(void) {
            return daily_waning_VEc;
        }

        float get_VEt(void) {
            return VEt;
        }

        float get_daily_waning_VEt(void) {
            return daily_waning_VEt;
        }

        Immunisation_Type get_immunisation_type(void) {
            return immunisation;
        }
        
    private:
        unsigned date;
        float VEc, daily_waning_VEc;    // Vaccine efficacy against symptomatic infection to the targeted virus
        float VEt, daily_waning_VEt;    // Vaccine efficacy against forward transmission to the targeted virus
        Immunisation_Type immunisation;
};

#endif